# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define reltag _redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%define section free

Name:           sun-istack-commons
Version:        2.6.1
Release:        2%{?reltag}%{?dist}
Epoch:          1
Summary:        Commons for JAXP, JAXB, SAAJ, and JAX-WS
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://istack-commons.dev.java.net
%if 0
rm -rf sun-istack-commons-2.6.1 sun-istack-commons-2.6.1.tar.bz2
svn -q export -r 151 https://svn.java.net/svn/istack-commons~svn/tags/istack-commons-2.6.1 sun-istack-commons-2.6.1 && \
tar cjf sun-istack-commons-2.6.1.tar.bz2 sun-istack-commons-2.6.1
%endif
Source0:        sun-istack-commons-2.6.1.tar.bz2
Patch0:         istack-commons-pom.patch
Provides:       istack-commons = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.6.0
Requires:       jpackage-utils
Requires:       ant
Requires:       codemodel >= 0:2.4
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  build-helper-maven-plugin
BuildRequires:  codemodel >= 0:2.4
BuildRequires:  dom4j
BuildRequires:  jboss-parent
BuildRequires:  junit
BuildRequires:  jvnet-parent
BuildRequires:  maven-shared-file-management
BuildRequires:  plexus-io
BuildRequires:  plexus-archiver
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch

%description
JAXP, JAXB, SAAJ, and JAX-WS projects are often used together 
by other projects (such as Mustang, Glassfish, and JWSDP to 
name a few.) But at the same time, they are released 
independently, and those technolgoies don't necessarily 
have dependencies between them.

To promote code reuse between these projects, we host the 
common part in a separate project, so that when we ship 
individually, we can each carry istack-commons.jar, and when
we deliver together into another technology, we can reduce 
the footprint. 

%package javadoc
Summary:        Javadoc for istack-commons
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%{_bindir}/find -type f \( -name '*.jar' -or -name '*.zip' \) | %{_bindir}/xargs -t rm
%patch0 -p1 -b .sav0

%build
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
# FIXME: system is broken in our maven
export MAVEN_OPTS="${MAVEN_OPTS} -Xbootclasspath/p:%{java_home}/lib/tools.jar"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%define prevversion 2.5-redhat-1
for d in `%{_bindir}/find maven2-brew -type d -name %{prevversion}`; do
    %{__mv} ${d}/* `/bin/echo ${d} | %{__sed} -e 's|%{prevversion}|%{namedversion}|;'`/
    %{__rm} -r ${d}/
done

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-buildtools/%{namedversion}/istack-commons-buildtools-%{namedversion}-sources.jar %{buildroot}%{_javadir}/istack-commons-buildtools-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-buildtools/%{namedversion}/istack-commons-buildtools-%{namedversion}.jar %{buildroot}%{_javadir}/istack-commons-buildtools-%{namedversion}.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-runtime/%{namedversion}/istack-commons-runtime-%{namedversion}-sources.jar %{buildroot}%{_javadir}/istack-commons-runtime-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-runtime/%{namedversion}/istack-commons-runtime-%{namedversion}.jar %{buildroot}%{_javadir}/istack-commons-runtime-%{namedversion}.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-test/%{namedversion}/istack-commons-test-%{namedversion}-sources.jar %{buildroot}%{_javadir}/istack-commons-test-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-test/%{namedversion}/istack-commons-test-%{namedversion}.jar %{buildroot}%{_javadir}/istack-commons-test-%{namedversion}.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-tools/%{namedversion}/istack-commons-tools-%{namedversion}-sources.jar %{buildroot}%{_javadir}/istack-commons-tools-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-tools/%{namedversion}/istack-commons-tools-%{namedversion}.jar %{buildroot}%{_javadir}/istack-commons-tools-%{namedversion}.jar
%{__cp} -p maven2-brew/com/sun/istack/maven-istack-commons-plugin/%{namedversion}/maven-istack-commons-plugin-%{namedversion}-sources.jar %{buildroot}%{_javadir}/maven-istack-commons-plugin-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/istack/maven-istack-commons-plugin/%{namedversion}/maven-istack-commons-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/maven-istack-commons-plugin-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-buildtools/%{namedversion}/istack-commons-buildtools-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-istack-commons-buildtools.pom
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-runtime/%{namedversion}/istack-commons-runtime-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-istack-commons-runtime.pom
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-test/%{namedversion}/istack-commons-test-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-istack-commons-test.pom
%{__cp} -p maven2-brew/com/sun/istack/istack-commons-tools/%{namedversion}/istack-commons-tools-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-istack-commons-tools.pom
%{__cp} -p maven2-brew/com/sun/istack/istack-commons/%{namedversion}/istack-commons-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-istack-commons.pom
%{__cp} -p maven2-brew/com/sun/istack/maven-istack-commons-plugin/%{namedversion}/maven-istack-commons-plugin-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-maven-istack-commons-plugin.pom

# depmaps
%add_to_maven_depmap com.sun.istack istack-commons-buildtools %{namedversion} JPP istack-commons-buildtools
%add_to_maven_depmap com.sun.istack istack-commons-runtime %{namedversion} JPP istack-commons-runtime
%add_to_maven_depmap com.sun.istack istack-commons-test %{namedversion} JPP istack-commons-test
%add_to_maven_depmap com.sun.istack istack-commons-tools %{namedversion} JPP istack-commons-tools
%add_to_maven_depmap com.sun.istack istack-commons %{namedversion} JPP istack-commons
%add_to_maven_depmap com.sun.istack maven-istack-commons-plugin %{namedversion} JPP maven-istack-commons-plugin
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/istack-commons

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/istack-commons-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/istack-commons-%{namedversion}
%{__ln_s} istack-commons-%{namedversion} %{buildroot}%{_javadocdir}/istack-commons

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc Licence.txt
%{_javadir}*/istack-commons-buildtools-%{namedversion}-sources.jar
%{_javadir}*/istack-commons-buildtools-sources.jar
%{_javadir}*/istack-commons-buildtools-%{namedversion}.jar
%{_javadir}*/istack-commons-buildtools.jar
%{_javadir}*/istack-commons-runtime-%{namedversion}-sources.jar
%{_javadir}*/istack-commons-runtime-sources.jar
%{_javadir}*/istack-commons-runtime-%{namedversion}.jar
%{_javadir}*/istack-commons-runtime.jar
%{_javadir}*/istack-commons-test-%{namedversion}-sources.jar
%{_javadir}*/istack-commons-test-sources.jar
%{_javadir}*/istack-commons-test-%{namedversion}.jar
%{_javadir}*/istack-commons-test.jar
%{_javadir}*/istack-commons-tools-%{namedversion}-sources.jar
%{_javadir}*/istack-commons-tools-sources.jar
%{_javadir}*/istack-commons-tools-%{namedversion}.jar
%{_javadir}*/istack-commons-tools.jar
%{_javadir}*/maven-istack-commons-plugin-%{namedversion}-sources.jar
%{_javadir}*/maven-istack-commons-plugin-sources.jar
%{_javadir}*/maven-istack-commons-plugin-%{namedversion}.jar
%{_javadir}*/maven-istack-commons-plugin.jar
%{_mavenpomdir}/JPP-istack-commons-buildtools.pom
%{_mavenpomdir}/JPP-istack-commons-runtime.pom
%{_mavenpomdir}/JPP-istack-commons-test.pom
%{_mavenpomdir}/JPP-istack-commons-tools.pom
%{_mavenpomdir}/JPP-istack-commons.pom
%{_mavenpomdir}/JPP-maven-istack-commons-plugin.pom
%{_mavendepmapfragdir}/istack-commons

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/istack-commons-%{namedversion}
%{_javadocdir}/istack-commons

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon May 21 2012 David Walluck <dwalluck@redhat.com> 0:2.6.1-2
- mark ant optional in tools pom
- remove activation and stax-api from runtime pom (in Java 6)
- update tools jar version from 1.5 to 1.6 in tools pom 
- update Release line

* Tue May 01 2012 David Walluck <dwalluck@redhat.com> 0:2.6.1-1
- 2.6.1
- recreate pom patch

* Wed Feb 23 2012 David Walluck <dwalluck@redhat.com> 0:2.5-0.1
- 2.5
- add repolib

* Sun Jul 17 2011 Ralph Apel <r.apel@r-apel.de> 1.0-3
- Fix for JPP6 and add parent pom

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 1.0-2
- Auto rebuild for JPackage 5 in mock

* Wed Apr 09 2008 Ralph Apel <r.apel at r-apel.de> - 1:1.0-1jpp
- 1.0 and bump epoch

* Tue Nov 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:20070625-1jpp
- First release
